# Include file used for all project makefiles

# Build dependency rules
# ===============================================================
THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSOCKET_DEP = vbsocket.h vbstypes.h

HTTPSERV_DEP = vbsocket.h httpserv.h \
	../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h

SERVER_DEP = vbsocket.h httpserv.h \
	 ../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)$(EXE_EXT)

thrapiw$(OBJ_EXT):	../../src/thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thrapiw.cpp

thelpers$(OBJ_EXT):	../../src/thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thelpers.cpp

thrpool$(OBJ_EXT):	../../src/thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/thrpool.cpp

vbthread$(OBJ_EXT):	../../src/vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbthread.cpp

vthreadt$(OBJ_EXT):	../../src/vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vthreadt.cpp

vbmutex$(OBJ_EXT):	../../src/vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbmutex.cpp

vbcond$(OBJ_EXT):	../../src/vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbcond.cpp

vbsema$(OBJ_EXT):	../../src/vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsema.cpp

server$(OBJ_EXT):	server.cpp $(SERVER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) server.cpp

vbsocket$(OBJ_EXT):	vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbsocket.cpp

httpserv$(OBJ_EXT):	httpserv.cpp $(HTTPSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) httpserv.cpp

# Make the executable
OBJECTS = vbsocket$(OBJ_EXT) httpserv$(OBJ_EXT) server$(OBJ_EXT) \
	vbthread$(OBJ_EXT) vbmutex$(OBJ_EXT) thrpool$(OBJ_EXT) \
	vthreadt$(OBJ_EXT) vbcond$(OBJ_EXT) vbsema$(OBJ_EXT) \
	thrapiw$(OBJ_EXT) thelpers$(OBJ_EXT)
# ===============================================================
